Bug 1287756 - Review Request: copy-jdk-configs - JDK config files copier
Review Request: copy-jdk-configs - JDK config files copier
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Simacek
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-02 10:39 EST by jiri vanek
Modified: 2016-02-26 21:08 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-02-26 21:01:28 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
msimacek: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description jiri vanek 2015-12-02 10:39:54 EST
Spec URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v1/copy_jdk_configs.spec
SRPM URL: <https://jvanek.fedorapeople.org/copy_jdk_configs/v1/copy_jdk_configs-1-1.src.rpm
RPM URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v1/copy_jdk_configs-1-1.noarch.rpm
Description: Utlity script to transfer jdks config files between upates or for archiving
Fedora Account System Username: jvanek
Comment 1 jiri vanek 2015-12-02 10:56:54 EST
Colol. Being insane form java, I screwed the only requirement this package have.
Requires java fixed by requires lua...Spec URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v2/copy_jdk_configs.spec
SRPM URL: <https://jvanek.fedorapeople.org/copy_jdk_configs/v2/copy_jdk_configs-1-1.src.rpm
RPM URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v2/copy_jdk_configs-1-1.noarch.rpm
Description: Utlity script to transfer jdks config files between upates or for archiving
Fedora Account System Username: jvanek
Comment 3 Mikolaj Izdebski 2015-12-02 12:08:48 EST
Major issues:

In general, "When naming packages for Fedora, the maintainer must use the dash '-' as the delimiter for name parts. The maintainer must NOT use an underscore '_'" [1]

There is no license file installed. You should add license file to upstream repo and install it using %license macro.

Source0 based on hg repo tip is a bad idea. You should use proper tags (preferably) or revision numbers / commit IDs.

Minor/cosmetic issues:
- "Epoch: 0" line is not needed.
- Empty sections (%prep, %install) can be removed.
- "rm -rf $RPM_BUILD_ROOT" is not needed.
- Group: tag is useless, consider removing it.

[1] https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Separators
Comment 4 Mikolaj Izdebski 2015-12-02 12:14:33 EST
Also there are several typos that need to be fixed in %description:
s/Utlity/Utility/
s/jdks/JDKs/
s/config/configuration/
s/upates/updates/
add dot at the end of sentence.
Comment 5 jiri vanek 2015-12-03 06:46:23 EST
Spec URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v3/copy-jdk-configs.spec
SRPM URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v3/copy-jdk-configs-1-1.src.rpm
RPM URL: https://jvanek.fedorapeople.org/copy_jdk_configs/v3/copy_jdk_configs-1-1.noarch.rpm

(In reply to Mikolaj Izdebski from comment #3)
> Major issues:
> 
> In general, "When naming packages for Fedora, the maintainer must use the
> dash '-' as the delimiter for name parts. The maintainer must NOT use an
> underscore '_'" [1]

Fixed.

> 
> There is no license file installed. You should add license file to upstream
> repo and install it using %license macro.

Currently I have no intentions to add license. Maybe I will in some future iteration (maybe when We agree with rest of team) But It wil be BSD or some other free license for sure.

> 
> Source0 based on hg repo tip is a bad idea. You should use proper tags
> (preferably) or revision numbers / commit IDs.

Sure. For now I had added revision number. In future, when there will be releases, it will be replaced by tags.

> 
> Minor/cosmetic issues:
> - "Epoch: 0" line is not needed.
removed

> - Empty sections (%prep, %install) can be removed.
unless you insists, I would like to keep them in. Just for "look and know"

> - "rm -rf $RPM_BUILD_ROOT" is not needed.

removed
> - Group: tag is useless, consider removing it.

removed (thanx!)
> 
> [1] https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Separators

(In reply to Mikolaj Izdebski from comment #4)
> Also there are several typos that need to be fixed in %description:
> s/Utlity/Utility/
> s/jdks/JDKs/
> s/config/configuration/
> s/upates/updates/
> add dot at the end of sentence.

fixed.
Comment 6 Mikolaj Izdebski 2015-12-03 10:26:59 EST
(In reply to jiri vanek from comment #5)
> > There is no license file installed. You should add license file to upstream
> > repo and install it using %license macro.
> 
> Currently I have no intentions to add license. Maybe I will in some future
> iteration (maybe when We agree with rest of team) But It wil be BSD or some
> other free license for sure.

If it is BSD license then you have to include license text in the package and there is no way around that.

> > Source0 based on hg repo tip is a bad idea. You should use proper tags
> > (preferably) or revision numbers / commit IDs.
> 
> Sure. For now I had added revision number. In future, when there will be
> releases, it will be replaced by tags.

If you use revision number then Release tag should comply with guidelines at https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Snapshot_packages, so it should be something like 0.1.20151203hg606138e2ec24

> > - Empty sections (%prep, %install) can be removed.
> unless you insists, I would like to keep them in. Just for "look and know"

Sure, that's fine.
Comment 8 Mikolaj Izdebski 2015-12-03 11:22:28 EST
Since I'm going for vacation, Michael will continue with the review.
Comment 10 Michael Simacek 2015-12-04 07:12:04 EST
- you should use %license macro for license instead of %doc. Also, it would be better if you didn't install the license manually and let rpmbuild handle it (copying it into build dir in %prep and then having just `%license LICENSE` in %files). Just FYI, you should have replaced <organization> with "Red Hat" in the license.
- is there any specific reason to have it installed in /usr/share? If it's supposed to be executed by the user, it should go to /usr/bin, otherwise to /usr/libexec.
- you should try to preserve timestamps of the files by using -p argument of cp
- is there some documentation for it? it would be nice if it had a manpage

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/doc/copy_jdk_configs
[x]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/doc/copy_jdk_configs
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[?]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: copy-jdk-configs-1.0-1.fc24.noarch.rpm
          copy-jdk-configs-1.0-1.fc24.src.rpm
copy-jdk-configs.src: W: strange-permission copy_jdk_configs.lua 755
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
1 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
copy-jdk-configs (rpmlib, GLIBC filtered):
    /usr/bin/lua
    lua
    lua-posix



Provides
--------
copy-jdk-configs:
    copy-jdk-configs



Source checksums
----------------
https://hg.fedorahosted.org/hg/copy_jdk_configs/raw-file/copy_jdk_configs-1.0/copy_jdk_configs.lua :
  CHECKSUM(SHA256) this package     : 4ce4d594897b9f099c03302943042cc46460198b858064439ce7d33be97e0b24
  CHECKSUM(SHA256) upstream package : 4ce4d594897b9f099c03302943042cc46460198b858064439ce7d33be97e0b24
https://hg.fedorahosted.org/hg/copy_jdk_configs/raw-file/copy_jdk_configs-1.0/LICENSE :
  CHECKSUM(SHA256) this package     : 44925e9dc7359ec6e978e6e7b4662785415825854f2c828f1a17694684340ecb
  CHECKSUM(SHA256) upstream package : 44925e9dc7359ec6e978e6e7b4662785415825854f2c828f1a17694684340ecb


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1287756
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 11 jiri vanek 2015-12-04 07:32:00 EST
TYVM!

(In reply to Michael Simacek from comment #10)
> - you should use %license macro for license instead of %doc. Also, it would
> be better if you didn't install the license manually and let rpmbuild handle
> it (copying it into build dir in %prep and then having just `%license
> LICENSE` in %files).

Thanx for this hint. I utterly forgot it exists. Fixed.

> Just FYI, you should have replaced <organization> with
> "Red Hat" in the license.

fixed in upstrea and new tag added.

> - is there any specific reason to have it installed in /usr/share? If it's
> supposed to be executed by the user, it should go to /usr/bin, otherwise to
> /usr/libexec.

My reason was that /usr/share was the only place where I found soem other lua scripts.
On contrary, libexec is full of perl or so I moved it there.

It is not expected to be launched by user.. hopefully...
I'm half inclined to put it more public and in /usr/bin (with man page and so...) But not now. Maybe later. (once people startto ask why openjdk update requires lua...)

> - you should try to preserve timestamps of the files by using -p argument of
> cp

fixed (via -a)

> - is there some documentation for it? it would be nice if it had a manpage

Not yet:( If it will ever go to path, then I will surely create man page.
Right now -h/--help is working!
And for testing.. feel free to get inspired by:
/usr/libexec/copy_jdk_configs.lua    --currentjvm "java-1.8.0-openjdk-1.8.0.66-3.b17.fc22.x86_64" --jvmdir "/usr/lib/jvm" --origname "java-1.8.0-openjdk" --origjavaver "1.8.0" --arch "x86_64" --debug true  --jvmDestdir /tmp

> 
> Package Review
> ==============
...
> [?]: Package functions as described.

Example usage(s) posted.

> [x]: Latest version is packaged.
> [x]: Package does not include license text files separate from upstream.
> [x]: Description and summary sections in the package spec file contains
>      translations for supported Non-English languages, if available.
> [x]: Package should compile and build into binary rpms on all supported
>      architectures.
> [-]: %check is present and all tests pass.
> [!]: Packages should try to preserve timestamps of original installed
>      files.

Should be fixed

> [x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
> [x]: Sources can be downloaded from URI in Source: tag
...
> 
> 
> Source checksums
> ----------------
> https://hg.fedorahosted.org/hg/copy_jdk_configs/raw-file/copy_jdk_configs-1.
> 0/copy_jdk_configs.lua :
>   CHECKSUM(SHA256) this package     :
> 4ce4d594897b9f099c03302943042cc46460198b858064439ce7d33be97e0b24
>   CHECKSUM(SHA256) upstream package :
> 4ce4d594897b9f099c03302943042cc46460198b858064439ce7d33be97e0b24
> https://hg.fedorahosted.org/hg/copy_jdk_configs/raw-file/copy_jdk_configs-1.
> 0/LICENSE :
>   CHECKSUM(SHA256) this package     :
> 44925e9dc7359ec6e978e6e7b4662785415825854f2c828f1a17694684340ecb
>   CHECKSUM(SHA256) upstream package :
> 44925e9dc7359ec6e978e6e7b4662785415825854f2c828f1a17694684340ecb


Sources changes. I will post URLs in next comment.

TY!
Comment 13 Michael Simacek 2015-12-04 07:55:29 EST
Looks ok to me now, APPROVED
Comment 14 Gwyn Ciesla 2015-12-04 08:31:29 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/copy-jdk-configs
Comment 15 Fedora Update System 2015-12-04 09:07:55 EST
copy-jdk-configs-1.1-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-c13fd741f6
Comment 16 Fedora Update System 2015-12-04 09:08:22 EST
copy-jdk-configs-1.1-1.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-2f6c7508b7
Comment 17 Fedora Update System 2015-12-04 09:08:52 EST
copy-jdk-configs-1.1-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-dba945af4a
Comment 18 Fedora Update System 2015-12-04 09:09:16 EST
copy-jdk-configs-1.1-1.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-1472d4279f
Comment 19 Fedora Update System 2015-12-04 11:50:35 EST
copy-jdk-configs-1.1-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update copy-jdk-configs'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-c13fd741f6
Comment 20 Fedora Update System 2015-12-04 12:20:12 EST
copy-jdk-configs-1.1-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update copy-jdk-configs'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-2f6c7508b7
Comment 21 Fedora Update System 2015-12-05 15:49:42 EST
copy-jdk-configs-1.1-1.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update copy-jdk-configs'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-1472d4279f
Comment 22 Fedora Update System 2015-12-05 15:50:57 EST
copy-jdk-configs-1.1-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update copy-jdk-configs'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-dba945af4a
Comment 23 Fedora Update System 2015-12-17 02:32:34 EST
copy-jdk-configs-1.1-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 24 Fedora Update System 2015-12-17 03:13:17 EST
copy-jdk-configs-1.1-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-02d81c02d9
Comment 25 Fedora Update System 2015-12-17 03:13:55 EST
copy-jdk-configs-1.1-2.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-c7f9f6130e
Comment 26 Fedora Update System 2015-12-17 03:53:03 EST
copy-jdk-configs-1.1-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 27 Fedora Update System 2015-12-18 09:19:44 EST
copy-jdk-configs-1.1-2.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update copy-jdk-configs'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-c7f9f6130e
Comment 28 Fedora Update System 2015-12-18 09:20:31 EST
copy-jdk-configs-1.1-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update copy-jdk-configs'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-02d81c02d9
Comment 29 Fedora Update System 2016-01-08 07:18:33 EST
copy-jdk-configs-1.1-3.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-aa6237387c
Comment 30 Fedora Update System 2016-01-08 07:18:58 EST
copy-jdk-configs-1.1-3.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-4ee40e04b9
Comment 31 Fedora Update System 2016-01-08 16:19:12 EST
copy-jdk-configs-1.1-3.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-aa6237387c
Comment 32 Fedora Update System 2016-01-08 16:23:34 EST
copy-jdk-configs-1.1-3.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-4ee40e04b9
Comment 33 Fedora Update System 2016-02-26 21:01:20 EST
copy-jdk-configs-1.1-3.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.
Comment 34 Fedora Update System 2016-02-26 21:08:28 EST
copy-jdk-configs-1.1-3.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.